> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.paradex.trade/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.paradex.trade/_mcp/server.

# Get vault positions

GET https://api.testnet.paradex.trade/v1/vaults/positions

Get positions opened by the given vault.


Reference: https://docs.paradex.trade/api/prod/vaults/get-positions

## Request

### Query parameters

- `address` (string, required) — Vault Address
- `strategy` (string, optional) — Vault Strategy Address

## Response

### 200

OK

- `results` (list of responses.PositionResp, optional) — Array of results

## Errors

### 400 Bad Request Error

Bad Request

- `data` (ResponsesApiErrorData, optional) — any additional data related to the error
- `error` (enum, optional) — unique immutable string identifier for specific error
  - Allowed values: `VALIDATION_ERROR`, `BINDING_ERROR`, `INTERNAL_ERROR`, `NOT_FOUND`, `SERVICE_UNAVAILABLE`, `INVALID_REQUEST_PARAMETER`, `ORDER_ID_NOT_FOUND`, `ORDER_IS_CLOSED`, `ORDER_IS_NOT_OPEN`, `INVALID_ORDER_SIZE`, `CLIENT_ORDER_ID_NOT_FOUND`, `DUPLICATED_CLIENT_ID`, `INVALID_PRICE_PRECISION`, `INVALID_SYMBOL`, `INVALID_TOKEN`, `INVALID_ETHEREUM_ADDRESS`, `INVALID_ETHEREUM_SIGNATURE`, `INVALID_STARKNET_ADDRESS`, `INVALID_STARKNET_SIGNATURE`, `STARKNET_SIGNATURE_VERIFICATION_FAILED`, `BAD_STARKNET_REQUEST`, `ETHEREUM_SIGNER_MISMATCH`, `ETHEREUM_HASH_MISMATCH`, `NOT_ONBOARDED`, `INVALID_TIMESTAMP`, `INVALID_BLOCK_EXPIRATION`, `ACCOUNT_NOT_FOUND`, `INVALID_ORDER_SIGNATURE`, `PUBLIC_KEY_INVALID`, `UNAUTHORIZED_ETHEREUM_ADDRESS`, `UNAUTHORIZED_ERROR`, `ETHEREUM_ADDRESS_ALREADY_ONBOARDED`, `MARKET_NOT_FOUND`, `ALLOWLIST_ENTRY_NOT_FOUND`, `USERNAME_IN_USE`, `GEO_IP_BLOCK`, `ETHEREUM_ADDRESS_BLOCKED`, `PROGRAM_NOT_FOUND`, `PROGRAM_NOT_SUPPORTED`, `INVALID_DASHBOARD`, `MARKET_NOT_OPEN`, `INVALID_REFERRAL_CODE`, `REQUEST_NOT_ALLOWED`, `PARENT_ADDRESS_ALREADY_ONBOARDED`, `INVALID_PARENT_ACCOUNT`, `INVALID_VAULT_OPERATOR_CHAIN`, `VAULT_OPERATOR_ALREADY_ONBOARDED`, `VAULT_NAME_IN_USE`, `VAULT_NOT_FOUND`, `VAULT_STRATEGY_NOT_FOUND`, `VAULT_LIMIT_REACHED`, `BATCH_SIZE_OUT_OF_RANGE`, `ISOLATED_MARKET_ACCOUNT_MISMATCH`, `NO_ACCESS_TO_MARKET`, `POINTS_SUMMARY_NOT_FOUND`, `ALGO_ID_NOT_FOUND`, `INVALID_DERIVATION_PATH`, `PROFILE_STATS_NOT_FOUND`, `INVALID_CHAIN`, `INVALID_LAYERSWAP_SWAP`, `INVALID_RHINOFI_REQUEST`, `INVALID_RHINOFI_QUOTE`, `INVALID_RHINOFI_QUOTE_COMMIT`, `SOCIAL_USERNAME_IN_USE`, `INVALID_OAUTH_REQUEST`, `RPI_ACCOUNT_NOT_WHITELISTED`, `SYSTEM_STATUS_POST_ONLY`, `SYSTEM_STATUS_CANCEL_ONLY`, `INVALID_MARKETING_CODE`, `INVALID_JOIN_WAITLIST_REQUEST`, `TRANSACTION_NOT_FOUND`, `OFFER_NOT_FOUND`, `MARKET_MARGIN_RESTRICTED`, `NOT_UNIQUE`, `ACCOUNT_ALREADY_REFERRED`, `ONBOARDING_PERIOD_EXPIRED`, `ONBOARDING_RATE_LIMITED`, `SUBACCOUNTS_LIMIT_EXCEEDED`, `INSUFFICIENT_MIN_CHAIN_BALANCE`, `INVALID_SUBKEY`, `TOKEN_LIMIT_REACHED`, `INVALID_TOKEN_SCOPE`, `INSUFFICIENT_TRANSFERRABLE_XP`, `TRANSFER_LIMIT_REACHED`
- `message` (string, optional) — detailed description of error and how to address it

## Types

### responses.PositionResp

- `account` (string, optional) — Account ID of the position
- `average_entry_price` (string, optional) — Average entry price
- `average_entry_price_usd` (string, optional) — Average entry price in USD
- `average_exit_price` (string, optional) — Average exit price
- `cached_funding_index` (string, optional) — Position cached funding index
- `closed_at` (integer, optional) — Position closed time
- `cost` (string, optional) — Position cost
- `cost_usd` (string, optional) — Position cost in USD
- `created_at` (integer, optional) — Position creation time
- `id` (string, optional) — Unique string ID for the position
- `last_fill_id` (string, optional) — Last fill ID to which the position is referring
- `last_updated_at` (integer, optional) — Position last update time
- `leverage` (string, optional) — Leverage of the position
- `liquidation_price` (string, optional) — Liquidation price of the position
- `market` (string, optional) — Market for position
- `realized_positional_funding_pnl` (string, optional) — Realized Funding PnL for the position. Reset to 0 when position is closed or flipped.
- `realized_positional_pnl` (string, optional) — Realized PnL including both positional PnL and funding payments. Reset to 0 when position is closed or flipped.
- `seq_no` (integer, optional) — Unique increasing number (non-sequential) that is assigned to this position update. Can be used to deduplicate multiple feeds
- `side` (enum, optional) — Position Side : Long or Short
  - Allowed values: `SHORT`, `LONG`
- `size` (string, optional) — Size of the position with sign (positive if long or negative if short)
- `status` (enum, optional) — Status of Position : Open or Closed
  - Allowed values: `OPEN`, `CLOSED`
- `unrealized_funding_pnl` (string, optional) — Unrealized running funding P&L for the position
- `unrealized_pnl` (string, optional) — Unrealized P&L of the position in the quote asset. Includes the unrealized running funding P&L.

### ResponsesApiErrorData

any additional data related to the error

## Examples

**Response**

```json
{
  "results": [
    {
      "account": "string",
      "average_entry_price": "29001.34",
      "average_entry_price_usd": "29001.34",
      "average_exit_price": "29001.34",
      "cached_funding_index": "1234.3",
      "closed_at": 1681493939981,
      "cost": "-10005.4623",
      "cost_usd": "-10005.4623",
      "created_at": 1681493939981,
      "id": "1234234",
      "last_fill_id": "1234234",
      "last_updated_at": 1681493939981,
      "leverage": "string",
      "liquidation_price": "string",
      "market": "BTC-USD-PERP",
      "realized_positional_funding_pnl": "12.234",
      "realized_positional_pnl": "-123.23",
      "seq_no": 1681471234972000000,
      "side": "SHORT",
      "size": "-0.345",
      "status": "OPEN",
      "unrealized_funding_pnl": "12.234",
      "unrealized_pnl": "-123.23"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.testnet.paradex.trade/v1/vaults/positions"

querystring = {"address":"address"}

response = requests.get(url, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.testnet.paradex.trade/v1/vaults/positions?address=address';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.testnet.paradex.trade/v1/vaults/positions?address=address"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.testnet.paradex.trade/v1/vaults/positions?address=address")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.testnet.paradex.trade/v1/vaults/positions?address=address")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.testnet.paradex.trade/v1/vaults/positions?address=address');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.testnet.paradex.trade/v1/vaults/positions?address=address");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.testnet.paradex.trade/v1/vaults/positions?address=address")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```